// main.c
// Main C file for the flash driver

typedef unsigned int	word;

// CPU registers
#define		TCR0	(*((volatile word*)0x0026))
#define		PRD0	(*((volatile word*)0x0025))
#define		IFR		(*((volatile word*)0x0001))
#define		IMR		(*((volatile word*)0x0000))
#define		SWWSR	(*((volatile word*)0x0028))

ioport volatile unsigned char port0;
interrupt void timer_interrupt()
{
	static short counter = 0;
//	asm(" SSBX INTM");		// Disable interrupts
	if(counter == 10)
	{
		port0 ^= 0x07;
		counter = 0;
	}
	else
		counter++;
	// Clear the interrupt
	IFR = 0x08;
//	asm(" RSBX INTM");		// Reenable interrupts
}

void setup_timer()
{
	asm(" STM #16,26h");	// Stop the timer
	asm(" STM #65535,25h");	// Period = 65536
	asm(" STM #15,26h");	// Start the timer, prescaler = 16
}

void setup_interrupt()
{
	asm(" SSBX INTM");	// Globally disable interrupts
	asm(" STM #8,1h");	// Clear any previous interrupt
	asm(" STM #8,0h");	// Enable the timer0 interrupt
	asm(" RSBX INTM");	// Globally enable interrupts
}

void main()
{
	// Setup the number of wait states for the board
	SWWSR = 0xD884;	

	port0 = 0x05;
	// Setup the timer for us to use
	setup_timer();
	
	// Setup the interrupt handler
	setup_interrupt();

	// Finally, go into a loop to allow the interrupt to execute
	while(1);
}
